lab_1/urls.py
from django.conf.urls import url
from .views import index
#url for app
urlpatterns = [
    url(r'^$', index, name='index'),
]

lab_7/urls.py
from django.conf.urls import url
from .views import index,add_friend,validate_npm,delete_friend,friend_list,friend_list_json,get_next_prev

urlpatterns = [
	 url(r'^$', index, name='index'),
	 url(r'^add-friend/$', add_friend, name='add-friend'),
	 url(r'^validate-npm/$', validate_npm, name='validate-npm'),
	 url(r'delete-friend/(?P<friend_id>[0-9]+)/$', delete_friend, name='delete-friend'),
	 url(r'^get-friend-list/$', friend_list_json, name='get-friend-list'),
	 url(r'^friend-list/$',friend_list,name='friend-list'),
	 url(r'^get-next-prev/$',get_next_prev,name='get-next-prev'),
]

praktikum/urls.py
from django.conf.urls import url, include
from django.views.generic.base import RedirectView
from django.contrib import admin
from django.conf import settings
from django.conf.urls.static import static
import lab_1.urls as lab_1
import lab_2.urls as lab_2
import lab_2_addon.urls as lab_2_addon
import lab_3.urls as lab_3
import lab_4.urls as lab_4
import lab_5.urls as lab_5
import lab_6.urls as lab_6
import lab_7.urls as lab_7
import lab_8.urls as lab_8
import lab_9.urls as lab_9
from lab_1.views import index as index_lab1


urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^lab-1/', include(lab_1,namespace='lab-1')),
    url(r'^lab-2/', include(lab_2,namespace='lab-2')),
    url(r'^lab-2-addon/', include(lab_2_addon,namespace='lab-2-addon')),
    #url(r'^$', index_lab1, name='index'),
    #url(r'^$',include(lab_2,namespace='index')),
    url(r'^$',RedirectView.as_view(url='lab-4/',permanent=True),name="go-to-landing-page"),
    url(r'^lab-3/', include(lab_3,namespace='lab-3')),
    url(r'^lab-4/', include(lab_4,namespace='lab-4')),
    url(r'^lab-5/', include(lab_5,namespace='lab-5')),
    url(r'^lab-6/', include(lab_6,namespace='lab-6')),
    url(r'^lab-7/', include(lab_7,namespace='lab-7')),
    url(r'^lab-8/', include(lab_8,namespace='lab-8')),
	url(r'^lab-9/', include(lab_9,namespace='lab-9')),
    ] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

lab_7/models.py
from django.db import models

class Friend(models.Model):
	friend_name = models.CharField(max_length=400)
	npm = models.CharField(max_length=250)
	added_at = models.DateField(auto_now_add=True)

# Create your models here.

lab_7/views.py
from django.shortcuts import render,redirect
from django.http import HttpResponse, HttpResponseRedirect, JsonResponse
from django.views.decorators.csrf import csrf_exempt
from django.core import serializers

from .models import Friend
from .api_csui_helper.csui_helper import CSUIhelper
import os
import json

response = {}
csui_helper = CSUIhelper()

def index(request):
    # Page halaman menampilkan list mahasiswa yang ada
    # TODO berikan akses token dari backend dengan menggunakaan helper yang ada

    mahasiswa_list = csui_helper.instance.get_mahasiswa_list()
    #next = csui_helper.instance.get_next_mahasiswa_list()
    #prev = csui_helper.instance.get_prev_mahasiswa_list()
    access_token =  csui_helper.instance.get_access_token()
    client_id = csui_helper.instance.get_client_id()
    #auth = csui_helper.instance.get_auth_param_dict()
    
    friend_list = Friend.objects.all()
    response = {"mahasiswa_list": mahasiswa_list, "friend_list": friend_list,"author":"Dennis Febri Dien","at":access_token,"ci":client_id}
    html = 'lab_7/lab_7.html'
	
    return render(request, html, response)

@csrf_exempt
def friend_list_json(request):
	return JsonResponse({"friend_list":list(Friend.objects.values())})

@csrf_exempt
def get_next_prev(request):#pragma: no cover
    if request.method == 'POST':
        type = request.POST['type']
        pg = int(request.POST['pg'])
        link = csui_helper.instance.get_API_link()
        if(type=="previous"):
            pg -= 1
            if(pg!=1):
                link+= ("&page="+str(pg))
            
           
        else:
            pg+=1
            link+= ("&page="+(str(pg)))
        
        mahasiswa_list =  json.dumps(csui_helper.instance.get_list(link))
        
        return HttpResponse(mahasiswa_list,content_type="application/json")
    return
	
def friend_list(request):
    friend_list = Friend.objects.all()
    response['friend_list'] = friend_list
    html = 'lab_7/daftar_teman.html'
    return render(request, html, response)
	
	
@csrf_exempt
def add_friend(request):
    if request.method == 'POST':
        name = request.POST['name']
        npm = request.POST['npm']
        friend = Friend(friend_name=name, npm=npm)
        
        if Friend.objects.all().filter(npm=friend.npm).exists():
            data = {'is_taken': Friend.objects.filter(npm__exact=npm).exists()}
            return JsonResponse(data)
        friend.save()
        data = model_to_dict(friend)
        return HttpResponse(data, content_type="application/json")

def delete_friend(request, friend_id):
    Friend.objects.filter(id=friend_id).delete()
    return HttpResponseRedirect('/lab-7/')

@csrf_exempt
def validate_npm(request):
    npm = request.POST.get('npm', None)
    data = {
        'is_taken': Friend.objects.filter(npm__exact=npm).exists() #lakukan pengecekan apakah Friend dgn npm tsb sudah ada
		}
    return JsonResponse(data)

def model_to_dict(obj):
    data = serializers.serialize('json', [obj,])
    struct = json.loads(data)
    data = json.dumps(struct[0]["fields"])
    return data

lab_7/templates/lab_7/daftar_teman.html
{% extends "lab_7/layout/base.html" %}

{% block content %}
    <section name="friend-list" id="friend-list">
        <div class="container">
            <div class="row">
                <div class="col-md-8 col-lg-8">
                    <h2> friend Fasilkom</h2>
                    <div id="friend-list" class="list-group">

                    </div>
                </div>
            </div>
        </div>
    </section>
{% endblock %}
{% block javascript %}
    <script>
        $( document ).ready(function () {
           
            $.ajax({
                method: "GET",
                url: "{% url "lab-7:get-friend-list" %}",
                success: function (response) {
					var lst = response.friend_list;
					
					$(lst).each(function(index,x){
						html = '<a class="list-group-item clearfix" id='+'friend_'+x.id+'>'+x.friend_name+' ('+x.npm+')'+
						'<span class="pull-right"><span class="btn btn-xs btn-default" onClick="deleteFriend('+x.id+')">Delete sebagai teman</span></span></a>'
						$("#friend-list").append(html)
					});
                },
                error: function(error){
				 
                    
                }
            });
        });
		
		var deleteFriend = function(id) {
        $.ajax({
            method: "GET", 
            url: "/lab-7/delete-friend/"+id,
           
            success : function () {	
				$("#friend_"+id).remove()
            }
        });
    };
		
    </script>
{% endblock %}

lab_7/templates/lab_7/lab_7.html
  {% extends "lab_7/layout/base.html" %}
{% block content %}
<section name="mahasiswa-list" id="mahasiswa-list">
    <div class="container">
        <div class="row">
            <div class="col-md-8 col-lg-8">
                <h2> Mahasiswa Fasilkom</h2>
				
				
				<ul class="pager">
				  <li class="previous"><a href="#">Previous</a></li>
				  <li class="next"><a href="#">Next</a></li>
				</ul>
                <div class="list-group" id="mahasiswa-list">
                    {% if mahasiswa_list %}
                        {% for mahasiswa in mahasiswa_list %}
                            <a class="list-group-item clearfix">
                                {{ mahasiswa.nama }} ({{ mahasiswa.npm }})
                                <span class="pull-right">
                        <span class="btn btn-xs btn-default" onClick="addFriend('{{ mahasiswa.nama }}', '{{ mahasiswa.npm }}')">
                            Tambah sebagai teman
                        </span>
                    </span>
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Opps!</strong> Tidak ada mahasiswa
                        </div>
                    {% endif %}
                </div>
            </div>
            <div class="col-lg-4">
                <h2> Teman Saya </h2>
                <div class="list-group" id="friend-list">
                    {% if friend_list %}
                        {% for friend in friend_list %}
                            <a class="list-group-item clearfix">
                                {{ friend.friend_name }} ({{ friend.npm }})
                            </a>
                        {% endfor %}
                    {% else %}
                        <div class="alert alert-danger text-center">
                            <strong>Opps!</strong> Tidak ada teman
                        </div>
                    {% endif %}
                </div>
                <form id="add-friend" action="#">
                    {% csrf_token %}
                    <label for="field_npm">npm</label>
                    <input id="field_npm" type="text" name="npm" class="form-control"/>
                    <label for="field_name">name</label>
                    <input id="field_name" type="text" name="name" class="form-control"/>
                    <button type="submit">Tambah</button>
                </form>
            </div>
        </div>
    </div>
</section>
{% endblock %}
{% block javascript %}
<script>

	var page = 1;
    var addFriend = function(nama, npm) {
        $.ajax({
            method: "POST",
            url: "{% url "lab-7:add-friend" %}",
            data: { name: nama, npm: npm},
            success : function (friend) {
				if(friend.is_taken){
					alert("Mahasiswa tersebut sudah ditambahkan sebagai teman")
				}
				else{
					
					html = '<a class="list-group-item clearfix">' +
						friend.friend_name+' ('+friend.npm+')'+
						'</a>';
					$("#friend-list").append(html)
				}
            },
            error : function (error) {
                alert("Mahasiswa tersebut sudah ditambahkan sebagai teman")
            }
        });
    };

	$("li.previous").click(function(){
		
		
		$.ajax({
            method: "POST",
			data: {type:"previous",pg:page},
            url: "{% url "lab-7:get-next-prev" %}",
            
            success : function (friend) {
				if(page != 1){
					page-= 1;
					
					var lst = friend;
					
					var change = "";
					var temp;
					$(lst).each(function(index,x){
							temp =  '<a class="list-group-item clearfix">'+x.nama+' ('+x.npm+')<span class="pull-right"><span class="btn btn-xs btn-default" onClick="addFriend('+
							x.nama+', '+x.npm+
							')">Tambah sebagai teman</span></span></a>';
							change += temp;
					});
					$("div#mahasiswa-list").html(change);
				}
            },
            
        });
	})
	
	$("li.next").click(function(){
		
		
		$.ajax({
            method: "POST",
			data: {type:"next",pg:page},
            url: "{% url "lab-7:get-next-prev" %}",
            
            success : function (friend) {
				page+=1;
				var lst = friend;
				
				var change="";
				var temp;
				$(lst).each(function(index,x){
						temp =  '<a class="list-group-item clearfix">'+x.nama+' ('+x.npm+')<span class="pull-right"><span class="btn btn-xs btn-default" onClick="addFriend('+
						x.nama+', '+x.npm+
						')">Tambah sebagai teman</span></span></a>';
						change += temp;
				});
				$("div#mahasiswa-list").html(change);
				
            },
       
        });
	})
	
    $("#add-friend").on("submit", function () {
       name = $("#field_name").val()
       npm = $("#field_npm").val()
        addFriend(name, npm)
        event.preventDefault();
    });

    $("#field_npm").change(function () {
        console.log( $(this).val() );
        npm = $(this).val();
        $.ajax({
            method: "POST",
            url: '{% url "lab-7:validate-npm" %}',
            data: {
                'npm': npm
            },
            dataType: 'json',
            success: function (data) {
                console.log(data)
                if (data.is_taken) {
                    alert("Mahasiswa dengan npm seperti ini sudah ada");
                }
            }
        });
    });
</script>
{% endblock %}